SystemOrganization addCategory: #'NXTalk-Kernel'!
SystemOrganization addCategory: #'NXTalk-Building'!
SystemOrganization addCategory: #'NXTalk-Collections'!

RBProgramNodeVisitor subclass: #NXTCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTCompiler class methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 02:36'!
byteCodes
	^ Dictionary new
		add: #halt -> 0;
		add: #dup -> 1;
		add: #pushLocal -> 2;
		add: #pushArgument -> 3;
		add: #pushField -> 3;
		add: #pushBlock -> 4;
		add: #pushConstant -> 5;
		add: #pushGlobal -> 6;
		add: #pop -> 7;
		add: #popLocal -> 8;
		add: #popArgument -> 9;
		add: #popField -> 10;
		add: #send -> 11;
		add: #superSend -> 12;
		add: #returnLocal -> 13;
		add: #returnNonLocal -> 14;
		yourself! !

!NXTCompiler methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 02:19'!
compileMethod: methodString
	| ast |
	ast := RBParser parseMethod: methodString.
	self visitNode: ast.! !

Object subclass: #NXTImage
	instanceVariableNames: 'objects specialObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/20/2008 03:18'!
nil
	^ self specialObjects at: #nil! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/20/2008 03:18'!
nil: aValue
	^ self specialObjects at: #nil put: aValue! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:06'!
objects
	^ objects! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:06'!
objects: anObject
	objects := anObject! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:06'!
specialObjects
	^ specialObjects! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:06'!
specialObjects: anObject
	specialObjects := anObject! !

Object subclass: #NXTImageBuilder
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImageBuilder class methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 02:52'!
standardCategories
	^ #('NXTalk-Kernel' 'NXTalk-Collections')! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 02:54'!
compileClass: aClass
	! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 03:00'!
compileClasses
	self class standardCategories do: [ :category |
		(Smalltalk organization listAtCategoryNamed: category) do: [ :class |
			self compileClass: class ]].! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 03:21'!
createSpecialObjects
	self image nil: NXTImageObject new.
	self image nil nxtClass: (self objectForClass: NXTUndefinedObject)! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 03:06'!
createStandardImage
	self image: NXTImage new.
	self createSpecialObjects.
	self compileClasses.! !

!NXTImageBuilder methodsFor: 'accessing' stamp: 'mab 2/20/2008 02:50'!
image
	^ image! !

!NXTImageBuilder methodsFor: 'accessing' stamp: 'mab 2/20/2008 02:50'!
image: anObject
	image := anObject! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 03:14'!
objectForClass: anNXTClass
	| instance |
	instance := self new.
	anNXTClass instanceVariables do: [ :varName |
		instance instanceVariables 
			at: varName asSymbol 
			put: (self image specialObjects at: #nil) ].
	^ instance! !

!NXTImageBuilder methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:17'!
specialObjects
	^ self image specialObjects! !

Object subclass: #NXTImageObject
	instanceVariableNames: 'nxtClass instanceVariables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImageObject methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 03:10'!
initialize
	instanceVariables := Dictionary new.! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:03'!
instanceVariables
	^ instanceVariables! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:03'!
instanceVariables: anObject
	instanceVariables := anObject! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:04'!
nxtClass
	^ nxtClass! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:04'!
nxtClass: anObject
	nxtClass := anObject! !

Object subclass: #NXTObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTObject subclass: #NXTBoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTBoolean subclass: #NXTFalse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTBoolean subclass: #NXTTrue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTObject subclass: #NXTClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTObject subclass: #NXTCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Collections'!

NXTObject subclass: #NXTCompiledMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTObject subclass: #NXTSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

!NXTSystem methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 02:28'!
run! !

NXTObject subclass: #NXTUndefinedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!
